Scriptname Tentacus:Crackle:_T_PlayerScript extends ReferenceAlias

Actor Property PlayerRef Auto
FormList Property _T_HeatSources Auto
GlobalVariable Property _T_BBCF Auto
GlobalVariable Property _T_Cold Auto
GlobalVariable Property _T_Campsite Auto
GlobalVariable Property _T_Conquest Auto
GlobalVariable Property _T_KitKat Auto
GlobalVariable Property _T_KitKatESL Auto
GlobalVariable Property _T_Forage Auto
GlobalVariable Property _T_SitSleep Auto
GlobalVariable Property _T_Needs Auto
GlobalVariable Property _T_Woody Auto
Tentacus:Crackle:_T_QuestScript Property _T_CrackleQuest Auto

Event OnInit()
    CheckForPlugins()
    RegisterForMenuOpenCloseEvent("PauseMenu")
    Utility.wait(2.0)
    Debug.notification("[CRACKLE] Ready!")
EndEvent

Event OnPlayerLoadGame()
    RegisterForMenuOpenCloseEvent("PauseMenu")
    CheckForPlugins()
    _T_SitSleep.SetValue(0)
    _T_Forage.SetValue(0)
    Debug.Notification("[CRACKLE] Ready!")
EndEvent

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
    If (asMenuName == "PauseMenu") && (abOpening == False) && _T_Forage.GetValue() == 1
        Utility.Wait(1.0)
        _T_CrackleQuest.WoodForage()
        _T_Forage.SetValue(0)
    Endif

    If (asMenuName == "PauseMenu") && (abOpening == False) && _T_SitSleep.GetValue() == 1
        Utility.Wait(1.0)
        _T_CrackleQuest.SitOrSleep()
        _T_SitSleep.SetValue(0)
    Endif
EndEvent

Event OnPlayerSwimming()
    If _T_Cold.GetValue() < 17
        Debug.Notification("You are soaking wet!")
        _T_Cold.SetValue(18)
    Endif
EndEvent

; Event OnControlDown(string asKeybindID)
;     Debug.Notification("Control down: " + asKeybindID)
; EndEvent

; Event OnControlUp(string asKeybindID, float time)
;     Debug.Notification("Control up: " + asKeybindID + " held for " + time + " s")
; EndEvent

Function CheckForPlugins()
    Activator BBCF1 = Game.GetFormFromFile(0x00000800, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF2 = Game.GetFormFromFile(0x00000801, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF3 = Game.GetFormFromFile(0x00000802, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF4 = Game.GetFormFromFile(0x0000080f, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF5 = Game.GetFormFromFile(0x00000819, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF6 = Game.GetFormFromFile(0x0000081E, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF7 = Game.GetFormFromFile(0x00000826, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF8 = Game.GetFormFromFile(0x0000082A, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF9 = Game.GetFormFromFile(0x0000082B, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF10 = Game.GetFormFromFile(0x00000FC9, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF11 = Game.GetFormFromFile(0x00000FCA, "BuildableBurningCampfires.esp") as Activator
    Activator BBCF12 = Game.GetFormFromFile(0x00000FCB, "BuildableBurningCampfires.esp") as Activator
    Activator CampsiteFire = Game.GetFormFromFile(0x0000088F, "Campsite.esp") as Activator
    Activator ESLKatFire = Game.GetFormFromFile(0x0000088F, "KitcatsCampingGear_Portable.esl") as Activator
    Activator ESLKatFireHC = Game.GetFormFromFile(0x00000810, "KitcatsCampingGear_Portable.esl") as Activator
    Activator KatFire = Game.GetFormFromFile(0x0000088F, "KitcatsCampingGear_Portable.esp") as Activator
    Activator KatFireHC = Game.GetFormFromFile(0x00000810, "KitcatsCampingGear_Portable.esp") as Activator
    Activator NeedsFire = Game.GetFormFromFile(0x0001B2C7, "AdvancedNeeds2.esp") as Activator
    Static ConquestFire = Game.GetFormFromFile(0x0000A9A7, "Conquest.esp") as Static
    Static BarrelFire = Game.GetFormFromFile(0x00000F99, "woodysWastelandStuff.esp") as Static
    Static StoneFire1 = Game.GetFormFromFile(0x00003622, "woodysWastelandStuff.esp") as Static
    Static StoneFire2 = Game.GetFormFromFile(0x00003DEA, "woodysWastelandStuff.esp") as Static

    If Game.IsPluginInstalled("Campsite.esp") == True
        If _T_Campsite.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(CampsiteFire)
            Utility.Wait(2)
            Debug.Notification("Campsite Campfire added to Crackle")
            _T_Campsite.SetValue(1)
        Endif
    Else
        If _T_Campsite.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(CampsiteFire)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n Campsite.esp NOT FOUND! \n \n Campsite Campfire removed from Crackle")
            _T_Campsite.SetValue(0)
        Endif
    Endif

    If Game.IsPluginInstalled("AdvancedNeeds2.esp") == True
        If _T_Needs.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(NeedsFire)
            Utility.Wait(2)
            Debug.Notification("Advanced Needs 2 Campfire added to Crackle")
            _T_Needs.SetValue(1)
        Endif
    Else
        If _T_Needs.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(NeedsFire)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n AdvancedNeeds2.esp NOT FOUND! \n \n Advanced Needs 2 Campfire removed from Crackle")
            _T_Needs.SetValue(0)
        Endif
    Endif

    If Game.IsPluginInstalled("Conquest.esp") == True
        If _T_Conquest.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(ConquestFire)
            Utility.Wait(2)
            Debug.Notification("Conquest Campfire added to Crackle")
            _T_Conquest.SetValue(1)
        Endif
    Else
        If _T_Conquest.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(ConquestFire)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n Conquest.esp NOT FOUND! \n \n Conquest Campfire removed from Crackle")
            _T_Conquest.SetValue(0)
        Endif
    Endif

    If Game.IsPluginInstalled("KitcatsCampingGear_Portable.esp") == True
        If _T_KitKat.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(KatFireHC)
            _T_HeatSources.AddForm(KatFire)
            Utility.Wait(2)
            Debug.Notification("Kitcat's Camping Gear tents and fires added to Crackle")
            _T_KitKat.SetValue(1)
        Endif
    Else
        If _T_KitKat.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(KatFireHC)
            _T_HeatSources.RemoveAddedForm(KatFire)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n KitcatsCampingGear_Portable.esp NOT FOUND! \n \n Kitcat's Camping Gear tents and fires removed from Crackle")
            _T_KitKat.SetValue(0)
        Endif
    Endif

    If Game.IsPluginInstalled("KitcatsCampingGear_Portable.esl") == True
        If _T_KitKatESL.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(ESLKatFireHC)
            _T_HeatSources.AddForm(ESLKatFire)
            Utility.Wait(2)
            Debug.Notification("Kitcat's Camping Gear tents and fires added to Crackle")
            _T_KitKatESL.SetValue(1)
        Endif
    Else
        If _T_KitKatESL.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(ESLKatFireHC)
            _T_HeatSources.RemoveAddedForm(ESLKatFire)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n KitcatsCampingGear_Portable.esl NOT FOUND! \n \n Kitcat's Camping Gear tents and fires removed from Crackle")
            _T_KitKatESL.SetValue(0)
        Endif
    Endif

    If Game.IsPluginInstalled("woodysWastelandStuff.esp") == True
        If _T_Woody.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(BarrelFire)
            _T_HeatSources.AddForm(StoneFire1)
            _T_HeatSources.AddForm(StoneFire2)
            Utility.Wait(2)
            Debug.Notification("Woody's Wasteland Stuff added to Crackle")
            _T_Woody.SetValue(1)
        Endif
    Else
        If _T_Woody.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(BarrelFire)
            _T_HeatSources.RemoveAddedForm(StoneFire1)
            _T_HeatSources.RemoveAddedForm(StoneFire2)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n woodysWastelandStuff.esp NOT FOUND! \n \n Woody's Wasteland Stuff removed from Crackle")
            _T_Woody.SetValue(0)
        Endif
    Endif

    If Game.IsPluginInstalled("BuildableBurningCampfires.esp") == True
        If _T_BBCF.GetValue() == 0
            Utility.Wait(0.1)
            _T_HeatSources.AddForm(BBCF1)
            _T_HeatSources.AddForm(BBCF2)
            _T_HeatSources.AddForm(BBCF3)
            _T_HeatSources.AddForm(BBCF4)
            _T_HeatSources.AddForm(BBCF5)
            _T_HeatSources.AddForm(BBCF6)
            _T_HeatSources.AddForm(BBCF7)
            _T_HeatSources.AddForm(BBCF8)
            _T_HeatSources.AddForm(BBCF9)
            _T_HeatSources.AddForm(BBCF10)
            _T_HeatSources.AddForm(BBCF11)
            _T_HeatSources.AddForm(BBCF12)
            Utility.Wait(2)
            Debug.Notification("Buildable Burning Campfires added to Crackle")
            _T_BBCF.SetValue(1)
        Endif
    Else
        If _T_BBCF.GetValue() == 1
            Utility.Wait(0.1)
            _T_HeatSources.RemoveAddedForm(BBCF1)
            _T_HeatSources.RemoveAddedForm(BBCF2)
            _T_HeatSources.RemoveAddedForm(BBCF3)
            _T_HeatSources.RemoveAddedForm(BBCF4)
            _T_HeatSources.RemoveAddedForm(BBCF5)
            _T_HeatSources.RemoveAddedForm(BBCF6)
            _T_HeatSources.RemoveAddedForm(BBCF7)
            _T_HeatSources.RemoveAddedForm(BBCF8)
            _T_HeatSources.RemoveAddedForm(BBCF9)
            _T_HeatSources.RemoveAddedForm(BBCF10)
            _T_HeatSources.RemoveAddedForm(BBCF11)
            _T_HeatSources.RemoveAddedForm(BBCF12)
            Utility.Wait(2)
            Debug.MessageBox("WARNING! \n \n BuildableBurningCampfires.esp NOT FOUND! \n \n Buildable Burning Campfires removed from Crackle")
            _T_BBCF.SetValue(0)
        Endif
    Endif
EndFunction