Scriptname Tentacus:Crackle:_T_QuestScript extends Quest

Actor Property PlayerRef Auto
ActorValue Property Health Auto Const
ActorValue Property RightMobilityCondition Auto Const
ActorValue Property LeftMobilityCondition Auto Const
ActorValue Property PerceptionCondition Auto Const
Bool Property Laying Auto
Bool Property Sitting Auto
Bool Property Warming Auto
FormList Property _T_HeatSources Auto
FormList Property _T_PO_Markers Auto
GlobalVariable Property _T_Campsite Auto
GlobalVariable Property _T_Cold Auto
GlobalVariable Property _T_CoolTimer Auto
GlobalVariable Property _T_Cozy Auto
GlobalVariable Property _T_KitKat Auto
GlobalVariable Property _T_KitKatESL Auto
GlobalVariable Property _T_SaveValue Auto
GlobalVariable Property _T_Warm Auto
GlobalVariable Property _T_WarmTimer Auto
GlobalVariable Property _T_Wet Auto
GlobalVariable Property pGameHour Auto Mandatory
Message Property _T_SitPosMessage Auto
Message Property _T_SitSleepMessage Auto
Message Property _T_SitSleepMessage2 Auto
Message Property _T_SitWaitMessage Auto
Message Property _T_SleepMessage Auto
MiscObject Property c_Wood_scrap Auto
Potion Property _T_StupiderSolution Auto
Potion Property _T_StupidSolution Auto
Potion Property _T_Wildberry Auto
Potion Property _T_Save Auto
Sound Property FSTnpcGrassAWalk Auto
Sound Property FSTPlayerWoodJumpDown Auto
Sound Property NPCFeralGhoulAmbushGetUpFaceDown Auto
Sound Property NPCFeralGhoulAmbushGetUpFaceUp Auto
Sound Property NPCFeralGhoulAttackCharge Auto
Sound Property NPCHumanKillPairedH2HJudoThrowNeckBreak Auto
Sound Property NPCRobotEyebotIdleGeneric Auto
Sound Property NPCRobotProtectronFootWalkL Auto
Sound Property QSTMK03DogViciousBark Auto
Sound Property QSTMK03DogViciousGrowl Auto
Sound Property QSTStringHitsMS05C Auto
Sound Property UIPerkNerdRageLAYERfemale Auto
Sound Property UIPerkNerdRageLAYERmale Auto
Sound Property UIVATSCriticalAvailable Auto
Sound Property WPNImpactKnucklesVsMetal Auto
Sound Property WPNRobotTurretHighTechLaserFire Auto
Sound Property _T_Wet_Voice Auto
Spell Property WaterRadiationHazard Auto ; Contact spell for common waters such as ocean
Weapon Property Machete Auto

Group ImageSpaceModifiers
    ImageSpaceModifier Property _T_messageBlurFadeOut Auto Const
    ImageSpaceModifier Property _T_messageBlurFadeIn  Auto Const
    ImageSpaceModifier Property _T_messageBlur        Auto Const
EndGroup

; Regex to find spot where to substitute this function can be found using regex
; \bGame(?:\s|\.)+FadeOutGame\((True|False).*\) replace with
; _T_TSEXProps._T_TSEXFunctions.ToggleMessageBG($1)
; where capture groups will take care of applying correct bool
; Fadeout Function
Function ToggleMessageBG(Bool apply_blur = True, Float imod_intensity = 1.0)
   If apply_blur
      _T_messageBlurFadeOut.Apply(imod_intensity)
      _T_messageBlurFadeOut.PopTo(_T_messageBlur, imod_intensity)
   Else
      Utility.Wait(0.2)
      _T_messageBlurFadeOut.Remove()
      _T_messageBlur.PopTo(_T_messageBlurFadeIn, imod_intensity)
      _T_messageBlurFadeIn.Remove()
   EndIf
EndFunction

Event OnInit()
    StartTimer(10, 100)
    StartTimer(15, 200)
endEvent

Event OnTimer(int TID)
    Float GetTime = GetCurrentHourOfDay()
    Float WarmTime = _T_WarmTimer.GetValue()
    Float CoolTime = _T_CoolTimer.GetValue()
    Formlist TentFull = Game.GetFormFromFile(0x00000803, "KitcatsCampingGear_Portable.esp") As Formlist
    Formlist TentFullESL = Game.GetFormFromFile(0x00000803, "KitcatsCampingGear_Portable.esl") As Formlist
    ObjectReference Fiya = Game.FindRandomReferenceOfAnyTypeInListFromRef(_T_HeatSources, PlayerRef, 300.0)
    Bool Shelter = Game.FindRandomReferenceOfAnyTypeInListFromRef(_T_PO_Markers, PlayerRef, 600.0) != None
    ; Passing None to FindRandomReferenceOfAnyTypeInListFromRef prints a line in log. This makes for one
    ; noisy output, so these checks should account for that. Replaced unnecessary refs with bools.
    ; ObjectReference Tent = None
    ; ObjectReference TentESL = None
    If _T_KitKat.GetValue()
        Shelter = Shelter || Game.FindRandomReferenceOfAnyTypeInListFromRef(TentFull, PlayerRef, 100.0) != None
    ElseIf _T_KitKatESL.GetValue()
        Shelter = Shelter || Game.FindRandomReferenceOfAnyTypeInListFromRef(TentFullESL, PlayerRef, 100.0) != None
    EndIf

    AAF:AAF_API AAF_API = Game.GetFormFromFile(0x00000F99, "AAF.esm") as AAF:AAF_API

    Utility.Wait(0.1)

    ; Bool Exposed = Shelter == None && Tent == None && TentESL == None \
    Bool Exposed = !Shelter && PlayerRef.IsInInterior() == False \
                   && Weather.GetCurrentWeather().GetClassification() > 1

    Utility.Wait(0.1)

    If Fiya != None
        If TID == 100 ;Warming timer
            _T_Wet.SetValue(0)
            If _T_Warm.GetValue() == 0
                If _T_Cozy.GetValue() == 0
                    _T_Cozy.SetValue(1)
                    Debug.Notification("The fire feels nice.")
                    Utility.Wait(2)
                Endif
                If _T_Cold.GetValue() > 0 && _T_Cozy.GetValue() == 1
                    If _T_Cold.GetValue() == 16 && _T_Cozy.GetValue() == 1
                        Debug.Notification("Steam rises from your drenched body.")
                    Elseif _T_Cold.GetValue() == 12 && _T_Cozy.GetValue() == 1
                        Debug.Notification("You very slightly less cold.")
                    Elseif _T_Cold.GetValue() == 10 && _T_Cozy.GetValue() == 1
                        Debug.Notification("You feel a little less cold.")
                    Elseif _T_Cold.GetValue() == 7 && _T_Cozy.GetValue() == 1
                        Debug.Notification("You feel less cold.")
                    Elseif _T_Cold.GetValue() == 5 && _T_Cozy.GetValue() == 1
                        Debug.Notification("You feel less cold but still chilly.")
                    Elseif _T_Cold.GetValue() == 3 && _T_Cozy.GetValue() == 1
                        Debug.Notification("You feel less chilly.")
                    Elseif _T_Cold.GetValue() == 1 && _T_Cozy.GetValue() == 1
                        Debug.Notification("You no longer feel chilly, and are starting to dry.")
                    Endif
                    _T_Cold.Mod(-1)
                Elseif _T_Cozy.GetValue() > 0 && _T_Cold.GetValue() == 0
                    If _T_Cozy.GetValue() == 3
                        Debug.Notification("You feel yourself warming up.")
                    Elseif _T_Cozy.GetValue() == 5
                        Debug.Notification("You feel a little warmer.")
                    Elseif _T_Cozy.GetValue() == 8
                        Debug.Notification("You feel much warmer.")
                    Elseif _T_Cozy.GetValue() == 10
                        ;It's raining shorten the effect
                        If Exposed
                            PlayerRef.EquipItem(_T_StupiderSolution, abSilent = true)
                        Else
                            PlayerRef.EquipItem(_T_StupidSolution, abSilent = true)
                        Endif
                        Debug.Notification("You feel warm.")
                        _T_Warm.SetValue(10)
                    Endif
                    _T_Cozy.Mod(1)
                Endif
            Else
                If _T_Warm.GetValue() > 0
                    ;It's raining shorten the effect
                    If Exposed
                        PlayerRef.EquipItem(_T_StupiderSolution, abSilent = true)
                        If _T_Warm.GetValue() == 10
                            Debug.Notification("You're as dry as you're likely to get.")
                            _T_Warm.SetValue(11)
                        Endif
                    Else
                        PlayerRef.EquipItem(_T_StupidSolution, abSilent = true)
                        If _T_Warm.GetValue() == 10 \
                        && Weather.GetCurrentWeather().GetClassification() > 1
                            Debug.Notification("You are dry.")
                            _T_Warm.SetValue(11)
                        Endif
                    Endif
                Endif
            Endif
        Endif;Warming timer
    Else
        _T_Cozy.SetValue(0)
        _T_Warm.SetValue(0)
        If Exposed
            If TID == 200 ;Cooling timer
                If _T_Cold.GetValue() == 0
                    If _T_Wet.GetValue() == 0
                        If Weather.GetCurrentWeather().GetClassification() == 2
                            Debug.Notification("The rain is chilly.")
                        Else
                            Debug.Notification("The snow is chilly.")
                        Endif
                    Elseif _T_Wet.GetValue() == 2
                        Debug.Notification("You feel Yourself cooling off.")
                    Elseif _T_Wet.GetValue() == 4
                        Debug.Notification("You feel a little chilly.")
                    Elseif _T_Wet.GetValue() == 6
                        Debug.Notification("You feel chilly.")
                    Elseif _T_Wet.GetValue() == 8
                        Debug.Notification("You feel quite chilly.")
                    Elseif _T_Wet.GetValue() == 10
                        Debug.Notification("You feel cold")
                        _T_Cold.SetValue(10)
                    Endif
                    _T_Wet.Mod(1)
                Else
                    _T_Wet.SetValue(0)
                Endif
            Endif ;Cooling timer
        Else
            If TID == 100 && !PlayerRef.HasSpell(WaterRadiationHazard) ;Warming timer
                If Shelter || Weather.GetCurrentWeather().GetClassification() == 0 \
                && GetTime > 9.0 && GetTime < 19.0

                    _T_Wet.SetValue(0)
                    If _T_Cold.GetValue() > 0
                        If _T_Cold.GetValue() == 16
                            Debug.Notification("You shiver as the water begins to evaporate.")
                        Elseif _T_Cold.GetValue() == 12
                            Debug.Notification("You shiver as you slowly dry off.")
                        Elseif _T_Cold.GetValue() == 10
                            Debug.Notification("You feel a little less cold.")
                        Elseif _T_Cold.GetValue() == 7
                            Debug.Notification("You feel less cold.")
                        Elseif _T_Cold.GetValue() == 5
                            Debug.Notification("You feel less cold but still chilly.")
                        Elseif _T_Cold.GetValue() == 3
                            Debug.Notification("You feel less chilly.")
                        Elseif _T_Cold.GetValue() == 1
                            Debug.Notification("You no longer feel chilly")
                        Endif
                        _T_Cold.Mod(-1)
                    Endif
                Else
                    If _T_Cold.GetValue() > 11
                        If _T_Cold.GetValue() == 16
                            Debug.Notification("You shiver as the water begins to evaporate.")
                        Elseif _T_Cold.GetValue() == 14
                            Debug.Notification("You shiver as you slowly dry off.")
                        Elseif _T_Cold.GetValue() == 12
                            Debug.Notification("You shiver as you slowly dry off.")
                        Endif
                        _T_Cold.Mod(-1)
                    Endif
                Endif
            Endif ;Warming timer
        Endif
    Endif

    If TID == 100 ;Warming timer
        StartTimer(WarmTime, 100)
    Endif

    If TID == 200 ;Cooling timer
        StartTimer(CoolTime, 200)
    Endif

    If PlayerRef.HasKeyword(AAF_API.AAF_ActorBusy) == 0
        If _T_SaveValue.GetValue() > 0
            ; PlayerRef.EquipItem(_T_Save, abSilent = true)
            _T_SaveValue.SetValue(0)
        Endif
    Endif

    If _T_Wet_Voice && _T_Cold.GetValue() >= 10
        _T_Wet_Voice.Play(PlayerRef)
    EndIf
EndEvent

Float Function GetCurrentHourOfDay() Global
    float Time = Utility.GetCurrentGameTime()
    Time -= Math.Floor(Time) ; Remove "previous in-game days passed" bit
    Time *= 24 ; Convert from fraction of a day to number of hours
    Return Time
EndFunction

Function WoodForage()
    MiscObject FireKit = Game.GetFormFromFile(0x0000088D, "Campsite.esp") as MiscObject
    Int ForageChance = Utility.RandomInt(0, 3)
    Int PerilChance = Utility.RandomInt(0, 6)
    Int D3 = Utility.RandomInt(0, 2)
    Int CoinFlip = Utility.RandomInt(0, 1)

    If PlayerRef.GetValue(RightMobilityCondition) > 0 && PlayerRef.GetValue(LeftMobilityCondition) > 0
        If !PlayerRef.IsInInterior()
            ToggleMessageBG(True)
            FSTnpcGrassAWalk.Play(PlayerRef)
            Utility.Wait (0.3)
            FSTnpcGrassAWalk.Play(PlayerRef)
            Utility.Wait (0.3)
            FSTnpcGrassAWalk.Play(PlayerRef)
            Debug.Messagebox("You set off into the surrounding area, looking for firewood.")
            Utility.Wait (0.3)
            If PerilChance > 2
                FSTPlayerWoodJumpDown.Play(PlayerRef)
                Bool ForageTools = PlayerRef.GetItemCount(Machete) > 0
                If ForageChance == 0 || ForageChance == 1 && ForageTools
                    pGameHour.Mod(0.5)
                    Debug.Messagebox("It doesn't take you too long to gather enough wood")
                Elseif ForageChance == 2 || ForageChance == 1 && !ForageTools
                    pGameHour.Mod(1)
                    Debug.Messagebox("It takes a while but you finally gather enough wood.")
                Else
                    pGameHour.Mod(2)
                    Debug.Messagebox("It takes forever... You are about to give up, when you find more wood than you need!")
                    PlayerRef.AddItem(c_Wood_scrap, 1)
                Endif
                If FireKit
                    PlayerRef.AddItem(FireKit, 1)
                Else
                    PlayerRef.AddItem(c_Wood_scrap, 2)
                Endif
                Utility.Wait(0.3)
                If ForageTools
                    Utility.Wait(0.5)
                    FSTPlayerWoodJumpDown.Play(PlayerRef)
                    PlayerRef.AddItem(c_Wood_scrap, 1)
                    UIVATSCriticalAvailable.Play(PlayerRef)
                    Debug.Messagebox("You were able to gather extra wood thanks to your machete.")
                Endif
            Elseif PerilChance == 0
                QSTStringHitsMS05C.Play(PlayerRef)
                Utility.Wait (0.5)
                QSTMK03DogViciousBark.Play(PlayerRef)
                Utility.Wait (0.3)
                QSTMK03DogViciousBark.Play(PlayerRef)
                Utility.Wait (0.1)
                Debug.Messagebox("You ran into a pack of vicious dogs!")
                Utility.Wait (0.1)
                QSTMK03DogViciousGrowl.Play(PlayerRef)
                Utility.Wait (0.5)
                QSTMK03DogViciousBark.Play(PlayerRef)
                Utility.Wait (0.1)
                If D3 == 0
                    Utility.Wait (0.2)
                    Debug.Messagebox("They took you by surprise! \n \n One of them mauled your leg!")
                    Utility.Wait (0.3)
                    Debug.Messagebox("You survived the ordeal, but were forced to limp back empty handed!")
                    Utility.Wait(1.0)
                    PlayerRef.DamageValue(LeftMobilityCondition, 100)
                    PlayerRef.DamageValue(Health, 5)
                Elseif D3 == 1
                    If CoinFlip == 0
                        Debug.Messagebox("You manage to run them off without much difficulty, but it wastes a lot of time. \n \n By the time you found some wood and made your way back, 2 hours had passed.")
                        Utility.Wait(0.1)
                        If FireKit
                            PlayerRef.AddItem(FireKit, 1)
                        Else
                            PlayerRef.AddItem(c_Wood_scrap, 2)
                        Endif
                        FSTPlayerWoodJumpDown.Play(PlayerRef)
                    Else
                        Debug.Messagebox("You managed to evade the pack but ended up getting lost. \n \n Eventually you found your way back, 2 hours later, tired and empty handed.")
                    Endif
                    pGameHour.Mod(1)
                Elseif D3 == 2
                    Debug.Messagebox("There were too many of them to take on! You had to run for your life!")
                    Utility.Wait(0.1)
                    NPCHumanKillPairedH2HJudoThrowNeckBreak.Play(PlayerRef)
                    Debug.Messagebox("You managed to lose them but in the process took a bad tumble and cracked your head on a rock! \n \n Bleary eyed and woozy, you somehow managed to make it back, though with no firewood for your trouble.")
                    PlayerRef.DamageValue(PerceptionCondition, 100)
                    PlayerRef.DamageValue(Health, 10)
                Endif
                pGameHour.Mod(1)
            Elseif PerilChance == 1
                NPCRobotProtectronFootWalkL.Play(PlayerRef)
                Utility.Wait (0.5)
                NPCRobotProtectronFootWalkL.Play(PlayerRef)
                Utility.Wait (0.5)
                NPCRobotProtectronFootWalkL.Play(PlayerRef)
                Utility.Wait (0.1)
                Debug.Messagebox("You ran into a rusty protectron!")
                Utility.Wait (0.1)
                NPCRobotProtectronFootWalkL.Play(PlayerRef)
                Utility.Wait (0.5)
                NPCRobotProtectronFootWalkL.Play(PlayerRef)
                Utility.Wait (0.1)
                If D3 == 0
                    Utility.Wait (0.2)
                    WPNRobotTurretHighTechLaserFire.Play(PlayerRef)
                    Utility.Wait (0.5)
                    WPNRobotTurretHighTechLaserFire.Play(PlayerRef)
                    Utility.Wait (0.5)
                    QSTStringHitsMS05C.Play(PlayerRef)
                    Utility.Wait (0.1)
                    Debug.Messagebox("Without warning the robot opened fire on you with it's laser! \n \n One of the bolts hit you in the leg!")
                    Utility.Wait (0.3)
                    Debug.Messagebox("You survived the ordeal, but were forced to limp back empty handed!")
                    Utility.Wait(1.0)
                    PlayerRef.DamageValue(LeftMobilityCondition, 100)
                    PlayerRef.DamageValue(Health, 5)
                    pGameHour.Mod(1)
                Elseif D3 == 1
                    If CoinFlip == 0
                        Debug.Messagebox("The robot didn't appear to be hostile but you decided to give it a wide berth. \n \n By the time you found some wood and made your way back, 2 hours had passed.")
                        Utility.Wait(0.1)
                        If FireKit
                            PlayerRef.AddItem(FireKit, 1)
                        Else
                            PlayerRef.AddItem(c_Wood_scrap, 2)
                        Endif
                        FSTPlayerWoodJumpDown.Play(PlayerRef)
                    Else
                        Debug.Messagebox("The robot didn't appear to be hostile but you decided to give it a wide berth and ended up getting lost. \n \n Eventually you found your way back, 2 hours later, tired and empty handed.")
                    Endif
                    pGameHour.Mod(2)
                Elseif D3 == 2
                    Utility.Wait(0.1)
                    WPNImpactKnucklesVsMetal.Play(PlayerRef)
                    Utility.Wait(0.1)
                    WPNImpactKnucklesVsMetal.Play(PlayerRef)
                    Debug.Messagebox("You got a little too close to the robot! \n \n To your shock it backhanded you... sending you flying!")
                    Utility.Wait(0.1)
                    NPCHumanKillPairedH2HJudoThrowNeckBreak.Play(PlayerRef)
                    Debug.Messagebox("You landed very badly and quickly passed out! When you regained consciousness, much later you were bleary eyed and woozy, but at least the robot was gone. \n \n You somehow managed to make it back, though with no firewood for your trouble.")
                    PlayerRef.DamageValue(PerceptionCondition, 100)
                    PlayerRef.DamageValue(Health, 10)
                    pGameHour.Mod(3)
                Endif
            Elseif PerilChance == 2
                If D3 == 0
                    Utility.Wait (0.1)
                    NPCRobotEyebotIdleGeneric.Play(PlayerRef)
                    Utility.Wait (0.3)
                    Debug.Messagebox("You come across an eyebot. It wasn't behaving like the ones you'd seen before. Rather than playing music or a message it just floated towards you menacingly.")
                    Utility.Wait (0.1)
                    NPCRobotEyebotIdleGeneric.Play(PlayerRef)
                    Utility.Wait (0.3)
                    WPNRobotTurretHighTechLaserFire.Play(PlayerRef)
                    Utility.Wait (0.5)
                    WPNRobotTurretHighTechLaserFire.Play(PlayerRef)
                    Utility.Wait (0.5)
                    QSTStringHitsMS05C.Play(PlayerRef)
                    Utility.Wait (0.1)
                    Debug.Messagebox("Without warning the robot opened fire on you with it's laser! \n \n One of the bolts hit you in the leg!")
                    Utility.Wait (0.3)
                    Debug.Messagebox("You survived the ordeal, but were forced to limp back empty handed!")
                    Utility.Wait(1.0)
                    PlayerRef.DamageValue(LeftMobilityCondition, 100)
                    PlayerRef.DamageValue(Health, 5)
                    pGameHour.Mod(1)
                Elseif D3 == 1
                    Debug.Messagebox("You only found a little bit of scrap wood, but you did find a handful of edible wild berries")
                    Utility.Wait(0.1)
                    PlayerRef.AddItem(c_Wood_scrap, 1)
                    PlayerRef.AddItem(_T_Wildberry, 3)
                    FSTPlayerWoodJumpDown.Play(PlayerRef)
                    pGameHour.Mod(2)
                Elseif D3 == 2
                    NPCFeralGhoulAmbushGetUpFaceDown.Play(PlayerRef)
                    Utility.Wait(0.1)
                    Debug.Messagebox("You ran into a large pack of Feral Ghouls!")
                    Utility.Wait(0.1)
                    NPCFeralGhoulAmbushGetUpFaceUp.Play(PlayerRef)
                    If CoinFlip == 0
                        Utility.Wait(0.5)
                        NPCFeralGhoulAttackCharge.Play(PlayerRef)
                        Utility.Wait(0.1)
                        Debug.Messagebox("They attacked you enmasse! They nearly got you, but somehow you were able to break free and lose them! \n \n Unfortunately while making your escape you turned your ankle badly and were forced to limp back emptyhanded!")
                        PlayerRef.DamageValue(LeftMobilityCondition, 100)
                        PlayerRef.DamageValue(Health, 5)
                        pGameHour.Mod(1.5)
                    Else
                        Utility.Wait(0.1)
                        Debug.Messagebox("Luckily they don't notice you, and you are able to slowly skirt around them. \n \n This eats up a lot of time, but you are able to find some wood eventually.")
                        Utility.Wait(0.1)
                        If FireKit
                            PlayerRef.AddItem(FireKit, 1)
                        Else
                            PlayerRef.AddItem(c_Wood_scrap, 2)
                        Endif
                        PlayerRef.AddItem(_T_Wildberry, 3)
                        FSTPlayerWoodJumpDown.Play(PlayerRef)
                        pGameHour.Mod(2)
                    Endif
                Endif
            Endif
            Utility.Wait(0.2)
            ToggleMessageBG(False)
        Else
            Debug.Messagebox("What would you forage in an interior?")
        Endif
    Else
        Debug.Messagebox("The pain from your injury prevents you from doing that.")
    Endif
EndFunction

Function SitOrSleep()
    ObjectReference Fiya = Game.FindRandomReferenceOfAnyTypeInListFromRef(_T_HeatSources, \
        PlayerRef, 300.0)
    AAF:AAF_API AAF_API = Game.GetFormFromFile(0x00000F99, "AAF.esm") as AAF:AAF_API
    If PlayerRef.HasKeyword(AAF_API.AAF_ActorBusy) == 0
        Laying  = False
        Sitting = False
        Warming = False
        If Fiya == None
            UIVATSCriticalAvailable.Play(PlayerRef)
            Int iButton = _T_SitSleepMessage.Show()
            If iButton == 0  ;LayDown
                SleepAnywhere()
            Elseif iButton == 1
                Sit()
            Endif
        Else
            UIVATSCriticalAvailable.Play(PlayerRef)
            Int iButton = _T_SitSleepMessage2.Show()
            If iButton == 0  ;LayDown
                SleepAnywhere()
            Elseif iButton == 1
                Sit()
            Elseif iButton == 2
                Warming = True
                aaf:aaf_api:SceneSettings settings = AAF_API.GetSceneSettings()
                settings.duration = -1
                settings.Position = "_T_WarmHands2"
                ; HHS compat
                settings.meta = "HHS_KeepHeight"
                Actor[] Actors = New Actor[1]
                Actors[0] = PlayerRef
                AAF_API.StartScene(Actors, settings)
            Elseif iButton == 3
                Warming = True
                aaf:aaf_api:SceneSettings settings = AAF_API.GetSceneSettings()
                settings.duration = -1
                settings.Position = "_T_WarmHands"
                ; HHS compat
                settings.meta = "HHS_KeepHeight"
                Actor[] Actors = New Actor[1]
                Actors[0] = PlayerRef
                AAF_API.StartScene(Actors, settings)
            Endif
        Endif
    Elseif PlayerRef.HasKeyword(AAF_API.AAF_ActorBusy) && Laying
        UIVATSCriticalAvailable.Play(PlayerRef)
        ToggleMessageBG(True)
        Int iButton = _T_SleepMessage.Show() ; Shows your menu.

        If iButton == 0 ;Sleep
            AAF_API.StopScene(PlayerRef)
            Utility.Wait(0.3)
            
            Int Sleep_ID = 0x000975d5 ; sleep max 3h
            If Fiya
                Sleep_ID = 0x00020C40 ; sleep max 5h
            EndIf

            Furniture Sleep = Game.GetFormFromFile(Sleep_ID, "Fallout4.esm") as Furniture
            ObjectReference SleepRef = PlayerRef.PlaceAtMe(Sleep, abForcePersist = false, \
                abInitiallyDisabled = False, abDeleteWhenAble = True)
            Utility.Wait(0.1)
            SleepRef.SetAngle(0.0, 0.0, 0.0)
            Utility.Wait(0.1)
            SleepRef.Activate(PlayerRef)
            Utility.Wait(0.1)
            SleepRef.Disable()
            SleepRef.Delete()

            Laying = False
            Utility.Wait(0.3)
            ToggleMessageBG(False)
        Elseif iButton == 1 ;Lay
            Laying = True
            Utility.Wait(0.1)
            ToggleMessageBG(False)
        Elseif iButton == 2 ;Get up
            Laying = False
            AAF_API.StopScene(PlayerRef)
            Utility.Wait(0.1)
            ToggleMessageBG(False)
        Endif
    Elseif PlayerRef.HasKeyword(AAF_API.AAF_ActorBusy) && Sitting
        UIVATSCriticalAvailable.Play(PlayerRef)
        ToggleMessageBG(True)
        Int jButton = _T_SitWaitMessage.Show()
        If jButton == 1
            pGameHour.Mod(1)
            Utility.Wait(0.1)
            _T_SaveValue.SetValue(1)
        Elseif jButton == 2
            pGameHour.Mod(5)
            Utility.Wait(0.1)
            _T_SaveValue.SetValue(1)
        Elseif jButton == 3
            Sitting = False
            AAF_API.StopScene(PlayerRef)
        Endif
        Utility.Wait(0.1)
        ToggleMessageBG(False)
    Elseif PlayerRef.HasKeyword(AAF_API.AAF_ActorBusy) && Warming
        Warming = False
        AAF_API.StopScene(PlayerRef)
    Endif
EndFunction

Function Sit()
    UIVATSCriticalAvailable.Play(PlayerRef)
    Int iButton = _T_SitPosMessage.Show()
    If iButton < 3
        Sitting = True
        AAF:AAF_API AAF_API = Game.GetFormFromFile(0x00000F99, "AAF.esm") as AAF:AAF_API
        aaf:aaf_api:SceneSettings settings = AAF_API.GetSceneSettings()
        settings.duration = -1
        settings.usePackages = True
        settings.excludeTags = None
        If iButton == 0
            ; settings.Position = "_T_Sit"
            settings.IncludeTags = "Sit_Relaxed"
        Elseif iButton == 1
            ; settings.Position = "_T_Sit2"
            settings.IncludeTags = "Sit_Weary"
        Elseif iButton == 2
            ; settings.Position = "_T_Sit3"
            settings.IncludeTags = "Sit_Wounded"
        Endif
        Actor[] Actors = New Actor [1]
        Actors[0] = PlayerRef
        AAF_API.StartScene(Actors, settings)
        Utility.Wait(2)
        ; Wait while walking is in progress as it can take longer than 8s
        While PlayerRef.HasKeyWord(AAF_API.AAF_MainQuestScript.AAF_isWalking)
            Utility.Wait(8)
        EndWhile
        Utility.Wait(8)
        UIVATSCriticalAvailable.Play(PlayerRef)
        ToggleMessageBG(True)
        Int jButton = _T_SitWaitMessage.Show()
        If jButton == 1
            pGameHour.Mod(1)
            Utility.Wait(0.1)
            _T_SaveValue.SetValue(1)
        Elseif jButton == 2
            pGameHour.Mod(5)
            Utility.Wait(0.1)
            _T_SaveValue.SetValue(1)
        Elseif jButton == 3
            Sitting = False
            AAF_API.StopScene(PlayerRef)
        Endif	
        Utility.Wait(0.1)
        ToggleMessageBG(False)
    Endif
EndFunction

Function SleepAnywhere()
    ObjectReference Fiya = Game.FindRandomReferenceOfAnyTypeInListFromRef(_T_HeatSources, \
        PlayerRef, 300.0)
    Int SleepChance = Utility.RandomInt(0, 2)
    Int LineChance = Utility.RandomInt(0, 1)

    AAF:AAF_API AAF_API = Game.GetFormFromFile(0x00000F99, "AAF.esm") as AAF:AAF_API
    aaf:aaf_api:SceneSettings settings = AAF_API.GetSceneSettings()
    settings.duration = -1
    settings.preventfurniture = False
    settings.usePackages = True
    settings.IncludeTags = "TenSleep"
    Actor[] Actors = New Actor [1]
    Actors[0] = PlayerRef
    AAF_API.StartScene(Actors, settings)
    ; Wait while walking is in progress as it can take longer than 8s
    Utility.Wait(2)
    While PlayerRef.HasKeyWord(AAF_API.AAF_MainQuestScript.AAF_isWalking)
        Utility.Wait(8)
    EndWhile
    Utility.Wait(16)
    UIVATSCriticalAvailable.Play(PlayerRef)
    ; Game.FadeOutGame(True, False, 0, 0.1, True)
    Int iButton = _T_SleepMessage.Show() ; Shows your menu.

    If iButton == 0 ;Sleep
        Int Sleep_ID = 0x000975d5 ; sleep max 3h
        If Fiya
            Sleep_ID = 0x00020C40 ; sleep max 5h
        EndIf

        ToggleMessageBG(True)
        Furniture Sleep = Game.GetFormFromFile(Sleep_ID, "Fallout4.esm") as Furniture
        ObjectReference SleepRef = PlayerRef.PlaceAtMe(Sleep, abForcePersist = false, \
            abInitiallyDisabled = False, abDeleteWhenAble = True)
        Utility.Wait(0.1)
        SleepRef.SetAngle(0.0, 0.0, 0.0)
        Utility.Wait(0.1)
        Int p1 = pGameHour.GetValue() as Int
        SleepRef.Activate(PlayerRef)
        Utility.Wait(0.1)
        SleepRef.Disable()
        SleepRef.Delete()
        ToggleMessageBG(False)
        Laying = False
        While Utility.IsInMenuMode()
            Utility.Wait(0.3)
        EndWhile
        Int p2 = pGameHour.GetValue() as Int
        AAF_API.StopScene(PlayerRef)
        While PlayerRef.HasKeyWord(AAF_API.AAF_ActorBusy)
            Utility.Wait(0.3)
        EndWhile
        ; Since sleep ends when player is in aaf scene autosave is not allowed,
        ; so we request it ourselfs only if player actually slept.
        ; This is hacky tho and might save rarely if timing is wrong.
        ; p2 != p1 is to check if player slept and didn't abort.
        If p2 != p1 && !playerRef.IsInCombat()
            Utility.Wait(0.3)
            Game.RequestAutoSave()
        EndIf
    Elseif iButton == 1 ;Lay
        Laying = True
        Utility.Wait(0.1)
        ; Game.FadeOutGame(False,False,0.1, 0.1)
    Elseif iButton == 2 ;Get up
        Laying = False
        AAF_API.StopScene(PlayerRef)
        Utility.Wait(0.1)
        ; Game.FadeOutGame(False,False,0.1, 0.1)
    Endif
EndFunction

Function GiveWood()
    MiscObject KatLogs = Game.GetFormFromFile(0x00000816, "KitcatsCampingGear_Portable.esp") as MiscObject
    MiscObject KatLogsESL = Game.GetFormFromFile(0x00000816, "KitcatsCampingGear_Portable.esl") as MiscObject
    Book KatManual = Game.GetFormFromFile(0x00000882, "KitcatsCampingGear_Portable.esp") as Book
    Book KatManualESL = Game.GetFormFromFile(0x00000882, "KitcatsCampingGear_Portable.esl") as Book
    Perk KatPerk = Game.GetFormFromFile(0x00000843, "KitcatsCampingGear_Portable.esp") as Perk
    Perk KatPerkESL = Game.GetFormFromFile(0x00000843, "KitcatsCampingGear_Portable.esl") as Perk

    If _T_KitKat.GetValue() == 1
        If PlayerRef.HasPerk(KatPerk) == 0
            PlayerRef.AddPerk(KatPerk)
        Endif
        If PlayerRef.GetItemCount(KatLogs) == 0
            PlayerRef.AddItem(KatLogs, 1)
        Else
            Debug.Notification("You already have Campfire wood")
        Endif
        If PlayerRef.GetItemCount(KatManual) == 0
            PlayerRef.AddItem(KatManual, 1)
        Else
            Debug.Notification("You already have the manual")
        Endif
    Elseif _T_KitKatESL.GetValue() == 1
        If PlayerRef.HasPerk(KatPerkESL) == 0
            PlayerRef.AddPerk(KatPerkESL)
        Endif
        If PlayerRef.GetItemCount(KatLogsESL) == 0
            PlayerRef.AddItem(KatLogsESL, 1)
        Else
            Debug.Notification("You already have Campfire wood")
        Endif
        If PlayerRef.GetItemCount(KatManualESL) == 0
            PlayerRef.AddItem(KatManualESL, 1)
        Else
            Debug.Notification("You already have the manual")
        Endif
    Else
        Debug.Messagebox("You need to install Kitcat's camping gear to use this function!")
    Endif
EndFunction